package com.hortonworks.spark.sql.hive.llap.wrapper;

import org.apache.hive.jdbc.HiveStatement;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import java.sql.SQLException;
import java.util.List;

public class QueryLogger implements Runnable {
    private HiveStatement stmt;
    private Logger logger;
    private static long SLEEP_INTERVAL_IN_MILI = 250;

    public QueryLogger (HiveStatement stmt) {
        this.stmt = stmt;
        logger = LoggerFactory.getLogger(this.getClass());
    }

    @Override
    public void run() {
        try {
            while (!stmt.isClosed () && stmt.hasMoreLogs()) {
                try {
                    List<String> logs = stmt.getQueryLog();
                    for (String log : logs) {
                        logger.info(log);
                    }
                    Thread.sleep(SLEEP_INTERVAL_IN_MILI);
                }
                catch (SQLException e) {
                    logger.warn("Error getting query logs", e);
                }
                catch (InterruptedException e) {

                }
            }
        }
        catch (SQLException e) {
            logger.warn ("Error accessing statement ", e);
        }
    }
}