package com.hortonworks.spark.sql.hive.llap.wrapper;

import org.apache.hive.jdbc.HiveStatement;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.SQLWarning;
import java.sql.Statement;

public class StatementWrapper implements java.sql.Statement {
    private Statement wrappedStmt;

    public StatementWrapper (Statement stmt) {
        wrappedStmt = stmt;
    }

    protected void startLogger(HiveStatement hStmt) {
        QueryLogger qLogger = new QueryLogger(hStmt);
        Thread t = new Thread (qLogger);
        t.setDaemon(true);
        t.start();
    }

    @Override
    public ResultSet executeQuery(String sql) throws SQLException {
        startLogger((HiveStatement) wrappedStmt);
        return wrappedStmt.executeQuery(sql);
    }

    @Override
    public int executeUpdate(String sql) throws SQLException {
        startLogger((HiveStatement) wrappedStmt);
        return wrappedStmt.executeUpdate(sql);
    }

    @Override
    public boolean execute(String sql) throws SQLException {
        startLogger((HiveStatement) wrappedStmt);
        return wrappedStmt.execute(sql);
    }

    @Override
    public void close() throws SQLException {
        wrappedStmt.close();
    }

    @Override
    public int getMaxFieldSize() throws SQLException {
        return wrappedStmt.getMaxFieldSize();
    }

    @Override
    public void setMaxFieldSize(int max) throws SQLException {
        wrappedStmt.setMaxFieldSize(max);
    }

    @Override
    public int getMaxRows() throws SQLException {
        return wrappedStmt.getMaxRows();
    }

    @Override
    public void setMaxRows(int max) throws SQLException {
        wrappedStmt.setMaxRows(max);
    }

    @Override
    public void setEscapeProcessing(boolean enable) throws SQLException {
        wrappedStmt.setEscapeProcessing(enable);
    }

    @Override
    public int getQueryTimeout() throws SQLException {
        return wrappedStmt.getQueryTimeout();
    }

    @Override
    public void setQueryTimeout(int seconds) throws SQLException {
        wrappedStmt.setQueryTimeout(seconds);
    }

    @Override
    public void cancel() throws SQLException {
        wrappedStmt.cancel();
    }

    @Override
    public SQLWarning getWarnings() throws SQLException {
        return wrappedStmt.getWarnings();
    }

    @Override
    public void clearWarnings() throws SQLException {
        wrappedStmt.clearWarnings();
    }

    @Override
    public void setCursorName(String name) throws SQLException {
        wrappedStmt.setCursorName(name);
    }

    @Override
    public ResultSet getResultSet() throws SQLException {
        return wrappedStmt.getResultSet();
    }

    @Override
    public int getUpdateCount() throws SQLException {
        return wrappedStmt.getUpdateCount();
    }

    @Override
    public boolean getMoreResults() throws SQLException {
        return wrappedStmt.getMoreResults();
    }

    @Override
    public void setFetchDirection(int direction) throws SQLException {
        wrappedStmt.setFetchDirection(direction);
    }

    @Override
    public int getFetchDirection() throws SQLException {
        return wrappedStmt.getFetchDirection();
    }

    @Override
    public void setFetchSize(int rows) throws SQLException {
        wrappedStmt.setFetchSize(rows);
    }

    @Override
    public int getFetchSize() throws SQLException {
        return wrappedStmt.getFetchSize();
    }

    @Override
    public int getResultSetConcurrency() throws SQLException {
        return wrappedStmt.getResultSetConcurrency();
    }

    @Override
    public int getResultSetType() throws SQLException {
        return wrappedStmt.getResultSetType();
    }

    @Override
    public void addBatch(String sql) throws SQLException {
        wrappedStmt.addBatch(sql);
    }

    @Override
    public void clearBatch() throws SQLException {
        wrappedStmt.clearBatch();
    }

    @Override
    public int[] executeBatch() throws SQLException {
        return wrappedStmt.executeBatch();
    }

    @Override
    public Connection getConnection() throws SQLException {
        return wrappedStmt.getConnection();
    }

    @Override
    public boolean getMoreResults(int current) throws SQLException {
        return wrappedStmt.getMoreResults(current);
    }

    @Override
    public ResultSet getGeneratedKeys() throws SQLException {
        return wrappedStmt.getGeneratedKeys();
    }

    @Override
    public int executeUpdate(String sql, int autoGeneratedKeys) throws SQLException {
        return wrappedStmt.executeUpdate(sql, autoGeneratedKeys);
    }

    @Override
    public int executeUpdate(String sql, int[] columnIndexes) throws SQLException {
        return wrappedStmt.executeUpdate(sql, columnIndexes);
    }

    @Override
    public int executeUpdate(String sql, String[] columnNames) throws SQLException {
        return wrappedStmt.executeUpdate(sql, columnNames);
    }

    @Override
    public boolean execute(String sql, int autoGeneratedKeys) throws SQLException {
        return wrappedStmt.execute(sql, autoGeneratedKeys);
    }

    @Override
    public boolean execute(String sql, int[] columnIndexes) throws SQLException {
        return wrappedStmt.execute(sql, columnIndexes);
    }

    @Override
    public boolean execute(String sql, String[] columnNames) throws SQLException {
        return wrappedStmt.execute(sql, columnNames);
    }

    @Override
    public int getResultSetHoldability() throws SQLException {
        return wrappedStmt.getResultSetHoldability();
    }

    @Override
    public boolean isClosed() throws SQLException {
        return wrappedStmt.isClosed();
    }

    @Override
    public void setPoolable(boolean poolable) throws SQLException {
        wrappedStmt.setPoolable(poolable);
    }

    @Override
    public boolean isPoolable() throws SQLException {
        return wrappedStmt.isPoolable();
    }

    @Override
    public void closeOnCompletion() throws SQLException {
        wrappedStmt.closeOnCompletion();
    }

    @Override
    public boolean isCloseOnCompletion() throws SQLException {
        return wrappedStmt.isCloseOnCompletion();
    }

    @Override
    public <T> T unwrap(Class<T> iface) throws SQLException {
        return wrappedStmt.unwrap(iface);
    }

    @Override
    public boolean isWrapperFor(Class<?> iface) throws SQLException {
        return wrappedStmt.isWrapperFor(iface);
    }
}